/* AutostartInfoBuilder.c generated by valac 0.56.0, the Vala compiler
 * generated from AutostartInfoBuilder.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

#define AUTOSTART_INFO_BUILDER_ENTRY "Desktop Entry"
#define AUTOSTART_INFO_BUILDER_SHOWIN "OnlyShowIn"
#define AUTOSTART_INFO_BUILDER_HIDEIN "NotShowIn"
#define AUTOSTART_INFO_BUILDER_DELAY "X-GNOME-Autostart-Delay"
#define AUTOSTART_INFO_BUILDER_TRYEXEC "TryExec"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_AUTOSTART_INFO_BUILDER (autostart_info_builder_get_type ())
#define AUTOSTART_INFO_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilder))
#define AUTOSTART_INFO_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilderClass))
#define IS_AUTOSTART_INFO_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AUTOSTART_INFO_BUILDER))
#define IS_AUTOSTART_INFO_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AUTOSTART_INFO_BUILDER))
#define AUTOSTART_INFO_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilderClass))

typedef struct _AutostartInfoBuilder AutostartInfoBuilder;
typedef struct _AutostartInfoBuilderClass AutostartInfoBuilderClass;
typedef struct _AutostartInfoBuilderPrivate AutostartInfoBuilderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_AUTOSTART_INFO (autostart_info_get_type ())
typedef struct _AutostartInfo AutostartInfo;
typedef struct _ParamSpecAutostartInfoBuilder ParamSpecAutostartInfoBuilder;

struct _AutostartInfoBuilder {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AutostartInfoBuilderPrivate * priv;
};

struct _AutostartInfoBuilderClass {
	GTypeClass parent_class;
	void (*finalize) (AutostartInfoBuilder *self);
};

struct _AutostartInfoBuilderPrivate {
	gchar* desktop;
	GKeyFile* keyfile;
};

struct _AutostartInfo {
	gchar* filename;
	gboolean visibility;
	gint delay;
	gchar* executable;
};

struct _ParamSpecAutostartInfoBuilder {
	GParamSpec parent_instance;
};

static gint AutostartInfoBuilder_private_offset;
static gpointer autostart_info_builder_parent_class = NULL;

VALA_EXTERN gpointer autostart_info_builder_ref (gpointer instance);
VALA_EXTERN void autostart_info_builder_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_autostart_info_builder (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_autostart_info_builder (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_autostart_info_builder (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_autostart_info_builder (const GValue* value);
VALA_EXTERN GType autostart_info_builder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AutostartInfoBuilder, autostart_info_builder_unref)
VALA_EXTERN AutostartInfoBuilder* autostart_info_builder_new (const gchar* desktop);
VALA_EXTERN AutostartInfoBuilder* autostart_info_builder_construct (GType object_type,
                                                        const gchar* desktop);
static gboolean autostart_info_builder_load_file (AutostartInfoBuilder* self,
                                           const gchar* path);
static gboolean autostart_info_builder_get_visibility (AutostartInfoBuilder* self);
static gboolean autostart_info_builder_find_desktop (AutostartInfoBuilder* self,
                                              const gchar* category,
                                              GKeyFile* kf,
                                              const gchar* desktop);
static gchar* autostart_info_builder_get_executable_name (AutostartInfoBuilder* self);
static gboolean autostart_info_builder_tryexec_is_validated (AutostartInfoBuilder* self,
                                                      GKeyFile* kf);
static gint autostart_info_builder_get_delay (AutostartInfoBuilder* self);
VALA_EXTERN GType autostart_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AutostartInfo* autostart_info_dup (const AutostartInfo* self);
VALA_EXTERN void autostart_info_free (AutostartInfo* self);
VALA_EXTERN void autostart_info_copy (const AutostartInfo* self,
                          AutostartInfo* dest);
VALA_EXTERN void autostart_info_destroy (AutostartInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (AutostartInfo, autostart_info_destroy)
VALA_EXTERN void autostart_info_builder_build (AutostartInfoBuilder* self,
                                   const gchar* path,
                                   AutostartInfo* result);
static void autostart_info_builder_finalize (AutostartInfoBuilder * obj);
static GType autostart_info_builder_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
autostart_info_builder_get_instance_private (AutostartInfoBuilder* self)
{
	return G_STRUCT_MEMBER_P (self, AutostartInfoBuilder_private_offset);
}

AutostartInfoBuilder*
autostart_info_builder_construct (GType object_type,
                                  const gchar* desktop)
{
	AutostartInfoBuilder* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (desktop != NULL, NULL);
	self = (AutostartInfoBuilder*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (desktop);
	_g_free0 (self->priv->desktop);
	self->priv->desktop = _tmp0_;
	return self;
}

AutostartInfoBuilder*
autostart_info_builder_new (const gchar* desktop)
{
	return autostart_info_builder_construct (TYPE_AUTOSTART_INFO_BUILDER, desktop);
}

static gboolean
autostart_info_builder_load_file (AutostartInfoBuilder* self,
                                  const gchar* path)
{
	gboolean _tmp5_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
		_tmp1_ = self->priv->keyfile;
		_tmp0_ = g_key_file_load_from_file (_tmp1_, path, G_KEY_FILE_NONE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = stdout;
		_tmp3_ = _error_;
		_tmp4_ = _tmp3_->message;
		fprintf (_tmp2_, "Error : %s", _tmp4_);
		result = FALSE;
		_g_error_free0 (_error_);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return _tmp5_;
}

/**
     * Returns the visibility of the desktop file
     *
     * Not visible if:
     *  - it doesn't exists in OnlyShowIn list
     *  - it exists in NotShowIn list
     *
     * @returns true if desktop file is visible, false otherwise.
     */
static gboolean
autostart_info_builder_get_visibility (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
		_tmp1_ = self->priv->keyfile;
		_tmp0_ = g_key_file_has_key (_tmp1_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_SHOWIN, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp2_ = FALSE;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
		if (_tmp0_) {
			GKeyFile* _tmp3_;
			const gchar* _tmp4_;
			_tmp3_ = self->priv->keyfile;
			_tmp4_ = self->priv->desktop;
			result = autostart_info_builder_find_desktop (self, AUTOSTART_INFO_BUILDER_SHOWIN, _tmp3_, _tmp4_);
			return result;
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = _error_;
		_tmp6_ = _tmp5_->message;
		g_warning ("AutostartInfoBuilder.vala:61: %s", _tmp6_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp7_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp7_;
	}
	{
		gboolean _tmp8_ = FALSE;
		GKeyFile* _tmp9_;
		_tmp9_ = self->priv->keyfile;
		_tmp8_ = g_key_file_has_key (_tmp9_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_HIDEIN, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp10_ = FALSE;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp10_;
		}
		if (_tmp8_) {
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = self->priv->keyfile;
			_tmp12_ = self->priv->desktop;
			result = !autostart_info_builder_find_desktop (self, AUTOSTART_INFO_BUILDER_HIDEIN, _tmp11_, _tmp12_);
			return result;
		}
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = _error_;
		_tmp14_ = _tmp13_->message;
		g_warning ("AutostartInfoBuilder.vala:69: %s", _tmp14_);
		_g_error_free0 (_error_);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp15_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp15_;
	}
	result = TRUE;
	return result;
}

/**
     * Check if executable name exists or if TryExec condition is met
     *
     * @returns the executable name or null.
     */
static gchar*
autostart_info_builder_get_executable_name (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GKeyFile* _tmp0_;
		_tmp0_ = self->priv->keyfile;
		if (autostart_info_builder_tryexec_is_validated (self, _tmp0_)) {
			gchar* _tmp1_ = NULL;
			GKeyFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			_tmp2_ = self->priv->keyfile;
			_tmp3_ = g_key_file_get_string (_tmp2_, AUTOSTART_INFO_BUILDER_ENTRY, "Exec", &_inner_error0_);
			_tmp1_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
					goto __catch0_g_key_file_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp4_ = _tmp1_;
			_tmp1_ = NULL;
			result = _tmp4_;
			_g_free0 (_tmp1_);
			return result;
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = _error_;
		_tmp6_ = _tmp5_->message;
		g_warning ("AutostartInfoBuilder.vala:86: %s", _tmp6_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	return result;
}

/**
     * @returns the delay in seconds before program has to be launched
     */
static gint
autostart_info_builder_get_delay (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
		_tmp1_ = self->priv->keyfile;
		_tmp0_ = g_key_file_has_key (_tmp1_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_DELAY, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp2_ = -1;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
		if (_tmp0_) {
			gint _tmp3_ = 0;
			GKeyFile* _tmp4_;
			_tmp4_ = self->priv->keyfile;
			_tmp3_ = g_key_file_get_integer (_tmp4_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_DELAY, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gint _tmp5_ = -1;
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
					goto __catch0_g_key_file_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp5_;
			}
			result = _tmp3_;
			return result;
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = _error_;
		_tmp7_ = _tmp6_->message;
		g_warning ("AutostartInfoBuilder.vala:102: %s", _tmp7_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp8_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp8_;
	}
	result = 0;
	return result;
}

void
autostart_info_builder_build (AutostartInfoBuilder* self,
                              const gchar* path,
                              AutostartInfo* result)
{
	AutostartInfo info = {0};
	gchar* _tmp0_;
	AutostartInfo _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = g_strdup (path);
	memset (&_tmp1_, 0, sizeof (AutostartInfo));
	_tmp1_.visibility = FALSE;
	_g_free0 (_tmp1_.filename);
	_tmp1_.filename = _tmp0_;
	info = _tmp1_;
	if (autostart_info_builder_load_file (self, path)) {
		gchar* _tmp2_;
		info.visibility = autostart_info_builder_get_visibility (self);
		_tmp2_ = autostart_info_builder_get_executable_name (self);
		_g_free0 (info.executable);
		info.executable = _tmp2_;
		info.delay = autostart_info_builder_get_delay (self);
	}
	*result = info;
	return;
}

static gboolean
autostart_info_builder_tryexec_is_validated (AutostartInfoBuilder* self,
                                             GKeyFile* kf)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (kf != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = g_key_file_has_key (kf, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_TRYEXEC, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp1_ = FALSE;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		if (_tmp0_) {
			gchar* tryexec = NULL;
			gchar* _tmp2_;
			const gchar* _tmp4_;
			_tmp2_ = g_key_file_get_string (kf, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_TRYEXEC, &_inner_error0_);
			tryexec = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp3_ = FALSE;
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
					goto __catch0_g_key_file_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp3_;
			}
			_tmp4_ = tryexec;
			if (_tmp4_ != NULL) {
				const gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gboolean _tmp8_;
				_tmp5_ = tryexec;
				_tmp6_ = g_find_program_in_path (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = _tmp7_ == NULL;
				_g_free0 (_tmp7_);
				if (_tmp8_) {
					result = FALSE;
					_g_free0 (tryexec);
					return result;
				}
			}
			_g_free0 (tryexec);
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = _error_;
		_tmp10_ = _tmp9_->message;
		g_warning ("AutostartInfoBuilder.vala:141: %s", _tmp10_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp11_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp11_;
	}
	result = TRUE;
	return result;
}

static gboolean
autostart_info_builder_find_desktop (AutostartInfoBuilder* self,
                                     const gchar* category,
                                     GKeyFile* kf,
                                     const gchar* desktop)
{
	gchar** show_list = NULL;
	gint show_list_length1 = 0;
	gint _show_list_size_ = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (category != NULL, FALSE);
	g_return_val_if_fail (kf != NULL, FALSE);
	g_return_val_if_fail (desktop != NULL, FALSE);
	{
		gchar** _tmp0_ = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gint _tmp5__length1;
		_tmp2_ = g_key_file_get_string_list (kf, AUTOSTART_INFO_BUILDER_ENTRY, category, &_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		_tmp0__length1 = _tmp1_;
		__tmp0__size_ = _tmp0__length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp3_ = FALSE;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
		_tmp4_ = _tmp0_;
		_tmp4__length1 = _tmp0__length1;
		_tmp0_ = NULL;
		_tmp0__length1 = 0;
		show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
		show_list = _tmp4_;
		show_list_length1 = _tmp4__length1;
		_show_list_size_ = show_list_length1;
		_tmp5_ = show_list;
		_tmp5__length1 = show_list_length1;
		{
			gchar** de_collection = NULL;
			gint de_collection_length1 = 0;
			gint _de_collection_size_ = 0;
			gint de_it = 0;
			de_collection = _tmp5_;
			de_collection_length1 = _tmp5__length1;
			for (de_it = 0; de_it < de_collection_length1; de_it = de_it + 1) {
				gchar* _tmp6_;
				gchar* de = NULL;
				_tmp6_ = g_strdup (de_collection[de_it]);
				de = _tmp6_;
				{
					const gchar* _tmp7_;
					_tmp7_ = de;
					if (g_strcmp0 (_tmp7_, desktop) == 0) {
						result = TRUE;
						_g_free0 (de);
						_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
						show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					_g_free0 (de);
				}
			}
		}
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = _error_;
		_tmp9_ = _tmp8_->message;
		g_warning ("AutostartInfoBuilder.vala:160: %s", _tmp9_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp10_ = FALSE;
		show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp10_;
	}
	result = FALSE;
	show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
value_autostart_info_builder_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_autostart_info_builder_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		autostart_info_builder_unref (value->data[0].v_pointer);
	}
}

static void
value_autostart_info_builder_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = autostart_info_builder_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_autostart_info_builder_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_autostart_info_builder_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		AutostartInfoBuilder * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = autostart_info_builder_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_autostart_info_builder_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	AutostartInfoBuilder ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = autostart_info_builder_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_autostart_info_builder (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	ParamSpecAutostartInfoBuilder* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AUTOSTART_INFO_BUILDER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_autostart_info_builder (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER), NULL);
	return value->data[0].v_pointer;
}

void
value_set_autostart_info_builder (GValue* value,
                                  gpointer v_object)
{
	AutostartInfoBuilder * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AUTOSTART_INFO_BUILDER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		autostart_info_builder_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		autostart_info_builder_unref (old);
	}
}

void
value_take_autostart_info_builder (GValue* value,
                                   gpointer v_object)
{
	AutostartInfoBuilder * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AUTOSTART_INFO_BUILDER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		autostart_info_builder_unref (old);
	}
}

static void
autostart_info_builder_class_init (AutostartInfoBuilderClass * klass,
                                   gpointer klass_data)
{
	autostart_info_builder_parent_class = g_type_class_peek_parent (klass);
	((AutostartInfoBuilderClass *) klass)->finalize = autostart_info_builder_finalize;
	g_type_class_adjust_private_offset (klass, &AutostartInfoBuilder_private_offset);
}

static void
autostart_info_builder_instance_init (AutostartInfoBuilder * self,
                                      gpointer klass)
{
	GKeyFile* _tmp0_;
	self->priv = autostart_info_builder_get_instance_private (self);
	_tmp0_ = g_key_file_new ();
	self->priv->keyfile = _tmp0_;
	self->ref_count = 1;
}

static void
autostart_info_builder_finalize (AutostartInfoBuilder * obj)
{
	AutostartInfoBuilder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilder);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->desktop);
	_g_key_file_unref0 (self->priv->keyfile);
}

static GType
autostart_info_builder_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_autostart_info_builder_init, value_autostart_info_builder_free_value, value_autostart_info_builder_copy_value, value_autostart_info_builder_peek_pointer, "p", value_autostart_info_builder_collect_value, "p", value_autostart_info_builder_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AutostartInfoBuilderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) autostart_info_builder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AutostartInfoBuilder), 0, (GInstanceInitFunc) autostart_info_builder_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType autostart_info_builder_type_id;
	autostart_info_builder_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AutostartInfoBuilder", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AutostartInfoBuilder_private_offset = g_type_add_instance_private (autostart_info_builder_type_id, sizeof (AutostartInfoBuilderPrivate));
	return autostart_info_builder_type_id;
}

GType
autostart_info_builder_get_type (void)
{
	static volatile gsize autostart_info_builder_type_id__once = 0;
	if (g_once_init_enter (&autostart_info_builder_type_id__once)) {
		GType autostart_info_builder_type_id;
		autostart_info_builder_type_id = autostart_info_builder_get_type_once ();
		g_once_init_leave (&autostart_info_builder_type_id__once, autostart_info_builder_type_id);
	}
	return autostart_info_builder_type_id__once;
}

gpointer
autostart_info_builder_ref (gpointer instance)
{
	AutostartInfoBuilder * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
autostart_info_builder_unref (gpointer instance)
{
	AutostartInfoBuilder * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		AUTOSTART_INFO_BUILDER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

