/* DirectoryReader.c generated by valac 0.56.0, the Vala compiler
 * generated from DirectoryReader.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DIRECTORY_READER (directory_reader_get_type ())
#define DIRECTORY_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_READER, DirectoryReader))
#define DIRECTORY_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_READER, DirectoryReaderClass))
#define IS_DIRECTORY_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_READER))
#define IS_DIRECTORY_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_READER))
#define DIRECTORY_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_READER, DirectoryReaderClass))

typedef struct _DirectoryReader DirectoryReader;
typedef struct _DirectoryReaderClass DirectoryReaderClass;
typedef struct _DirectoryReaderPrivate DirectoryReaderPrivate;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecDirectoryReader ParamSpecDirectoryReader;

struct _DirectoryReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryReaderPrivate * priv;
};

struct _DirectoryReaderClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryReader *self);
};

struct _DirectoryReaderPrivate {
	GHashTable* desktopFiles;
	GSList* autostart_files;
};

struct _ParamSpecDirectoryReader {
	GParamSpec parent_instance;
};

static gint DirectoryReader_private_offset;
static gpointer directory_reader_parent_class = NULL;

VALA_EXTERN gpointer directory_reader_ref (gpointer instance);
VALA_EXTERN void directory_reader_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_directory_reader (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_directory_reader (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_directory_reader (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_directory_reader (const GValue* value);
VALA_EXTERN GType directory_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DirectoryReader, directory_reader_unref)
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
VALA_EXTERN DirectoryReader* directory_reader_new (void);
VALA_EXTERN DirectoryReader* directory_reader_construct (GType object_type);
VALA_EXTERN void directory_reader_read_all (DirectoryReader* self);
VALA_EXTERN void directory_reader_read_from_config_dir (DirectoryReader* self,
                                            const gchar* config_dir);
VALA_EXTERN GSList* directory_reader_getFiles (DirectoryReader* self);
static void __lambda4_ (DirectoryReader* self,
                 const gchar* x,
                 const gchar* y);
static void ___lambda4__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static void directory_reader_finalize (DirectoryReader * obj);
static GType directory_reader_get_type_once (void);
static gssize _vala_array_length (gpointer array);

static inline gpointer
directory_reader_get_instance_private (DirectoryReader* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryReader_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

DirectoryReader*
directory_reader_construct (GType object_type)
{
	DirectoryReader* self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	self = (DirectoryReader*) g_type_create_instance (object_type);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
	_g_hash_table_unref0 (self->priv->desktopFiles);
	self->priv->desktopFiles = _tmp2_;
	return self;
}

DirectoryReader*
directory_reader_new (void)
{
	return directory_reader_construct (TYPE_DIRECTORY_READER);
}

void
directory_reader_read_all (DirectoryReader* self)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp1_ = _tmp0_ = g_get_system_config_dirs ();
	{
		gchar** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp1_;
		dir_collection_length1 = _vala_array_length (_tmp0_);
		for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
			gchar* _tmp2_;
			gchar* dir = NULL;
			_tmp2_ = g_strdup (dir_collection[dir_it]);
			dir = _tmp2_;
			{
				const gchar* _tmp3_;
				_tmp3_ = dir;
				directory_reader_read_from_config_dir (self, _tmp3_);
				_g_free0 (dir);
			}
		}
	}
	_tmp4_ = g_get_user_config_dir ();
	directory_reader_read_from_config_dir (self, _tmp4_);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

void
directory_reader_read_from_config_dir (DirectoryReader* self,
                                       const gchar* config_dir)
{
	const gchar* filename = NULL;
	gchar* autostart_dir = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (config_dir != NULL);
	_tmp0_ = g_build_filename (config_dir, "autostart", NULL);
	autostart_dir = _tmp0_;
	{
		GDir* d = NULL;
		const gchar* _tmp1_;
		GDir* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp1_ = autostart_dir;
		_tmp2_ = g_dir_open (_tmp1_, (guint) 0, &_inner_error0_);
		d = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			_g_free0 (autostart_dir);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = autostart_dir;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = g_strconcat ("Parsing: ", _tmp4_, NULL);
		_tmp6_ = _tmp5_;
		g_message ("DirectoryReader.vala:50: %s", _tmp6_);
		_g_free0 (_tmp6_);
		while (TRUE) {
			GDir* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			_tmp7_ = d;
			_tmp8_ = g_dir_read_name (_tmp7_);
			filename = _tmp8_;
			_tmp9_ = filename;
			if (!(_tmp9_ != NULL)) {
				break;
			}
			_tmp10_ = filename;
			if (g_str_has_suffix (_tmp10_, ".desktop")) {
				GHashTable* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp11_ = self->priv->desktopFiles;
				_tmp12_ = filename;
				_tmp13_ = g_strdup (_tmp12_);
				_tmp14_ = autostart_dir;
				_tmp15_ = filename;
				_tmp16_ = g_build_filename (_tmp14_, _tmp15_, NULL);
				g_hash_table_replace (_tmp11_, _tmp13_, _tmp16_);
			}
		}
		_g_dir_close0 (d);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_warning ("DirectoryReader.vala:59: Error: %s", _tmp18_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (autostart_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (autostart_dir);
}

static void
__lambda4_ (DirectoryReader* self,
            const gchar* x,
            const gchar* y)
{
	gchar* _tmp0_;
	g_return_if_fail (x != NULL);
	g_return_if_fail (y != NULL);
	_tmp0_ = g_strdup (y);
	self->priv->autostart_files = g_slist_append (self->priv->autostart_files, _tmp0_);
}

static void
___lambda4__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
	__lambda4_ ((DirectoryReader*) self, (const gchar*) key, (const gchar*) value);
}

GSList*
directory_reader_getFiles (DirectoryReader* self)
{
	GHashTable* _tmp0_;
	GSList* _tmp1_;
	GSList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->desktopFiles;
	g_hash_table_foreach (_tmp0_, ___lambda4__gh_func, self);
	_tmp1_ = self->priv->autostart_files;
	result = _tmp1_;
	return result;
}

static void
value_directory_reader_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_directory_reader_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		directory_reader_unref (value->data[0].v_pointer);
	}
}

static void
value_directory_reader_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_reader_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_directory_reader_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_directory_reader_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		DirectoryReader * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_reader_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_directory_reader_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	DirectoryReader ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_reader_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_directory_reader (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecDirectoryReader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DIRECTORY_READER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_directory_reader (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DIRECTORY_READER), NULL);
	return value->data[0].v_pointer;
}

void
value_set_directory_reader (GValue* value,
                            gpointer v_object)
{
	DirectoryReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DIRECTORY_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DIRECTORY_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_reader_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_reader_unref (old);
	}
}

void
value_take_directory_reader (GValue* value,
                             gpointer v_object)
{
	DirectoryReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DIRECTORY_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DIRECTORY_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_reader_unref (old);
	}
}

static void
directory_reader_class_init (DirectoryReaderClass * klass,
                             gpointer klass_data)
{
	directory_reader_parent_class = g_type_class_peek_parent (klass);
	((DirectoryReaderClass *) klass)->finalize = directory_reader_finalize;
	g_type_class_adjust_private_offset (klass, &DirectoryReader_private_offset);
}

static void
directory_reader_instance_init (DirectoryReader * self,
                                gpointer klass)
{
	self->priv = directory_reader_get_instance_private (self);
	self->priv->autostart_files = NULL;
	self->ref_count = 1;
}

static void
directory_reader_finalize (DirectoryReader * obj)
{
	DirectoryReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRECTORY_READER, DirectoryReader);
	g_signal_handlers_destroy (self);
	_g_hash_table_unref0 (self->priv->desktopFiles);
	(self->priv->autostart_files == NULL) ? NULL : (self->priv->autostart_files = (_g_slist_free__g_free0_ (self->priv->autostart_files), NULL));
}

static GType
directory_reader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_directory_reader_init, value_directory_reader_free_value, value_directory_reader_copy_value, value_directory_reader_peek_pointer, "p", value_directory_reader_collect_value, "p", value_directory_reader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryReader), 0, (GInstanceInitFunc) directory_reader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType directory_reader_type_id;
	directory_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DirectoryReader_private_offset = g_type_add_instance_private (directory_reader_type_id, sizeof (DirectoryReaderPrivate));
	return directory_reader_type_id;
}

GType
directory_reader_get_type (void)
{
	static volatile gsize directory_reader_type_id__once = 0;
	if (g_once_init_enter (&directory_reader_type_id__once)) {
		GType directory_reader_type_id;
		directory_reader_type_id = directory_reader_get_type_once ();
		g_once_init_leave (&directory_reader_type_id__once, directory_reader_type_id);
	}
	return directory_reader_type_id__once;
}

gpointer
directory_reader_ref (gpointer instance)
{
	DirectoryReader * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
directory_reader_unref (gpointer instance)
{
	DirectoryReader * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_READER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

